"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.messageAsyncIterator = exports.RobustWebSocket = void 0;
var RobustWebSocket = /** @class */ (function () {
    function RobustWebSocket(urlOrFactory, onmessage, options) {
        this.urlOrFactory = urlOrFactory;
        this.onmessage = onmessage;
        this.isOpen = false;
        this.closedManually = false;
        this.wantReconnect = true;
        this.options = {
            reconnectTimeoutMillis: 5000,
            onOpen: function (_) { },
            onDisconnect: function (_, _2) { }, // eslint-disable-line
        };
        this.pendingOnOpens = [];
        if (options) {
            this.options = __assign(__assign({}, this.options), options);
        }
        this.init();
    }
    RobustWebSocket.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var factory, _a, reinited;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.closedManually = false;
                        this.wantReconnect = true;
                        this.isOpen = false;
                        if (!(typeof this.urlOrFactory === "string")) return [3 /*break*/, 1];
                        // @ts-ignore  Ignore the error that comes from the compiler not being able to guarantee that
                        // this.ws will always be set to the same subtype of WebSocketLike.  We know it will be since
                        // this.urlOrFactory can only be set once.
                        this.ws = new WebSocket(this.urlOrFactory);
                        return [3 /*break*/, 4];
                    case 1:
                        factory = this.urlOrFactory();
                        if (!(factory instanceof Promise)) return [3 /*break*/, 3];
                        _a = this;
                        return [4 /*yield*/, factory];
                    case 2:
                        _a.ws = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        this.ws = factory;
                        _b.label = 4;
                    case 4:
                        reinited = false;
                        this.ws.onclose = function (ev) { return __awaiter(_this, void 0, void 0, function () {
                            var maybePromise;
                            var _this = this;
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        if (!this.options.onDisconnect) return [3 /*break*/, 2];
                                        maybePromise = this.options.onDisconnect(this.ws, this.closedManually);
                                        if (!maybePromise) return [3 /*break*/, 2];
                                        return [4 /*yield*/, maybePromise];
                                    case 1:
                                        _b.sent();
                                        _b.label = 2;
                                    case 2:
                                        if (!this.wantReconnect) {
                                            return [2 /*return*/];
                                        }
                                        console.log("Websocket to ".concat((_a = this.ws.url) !== null && _a !== void 0 ? _a : "unknown", " closed or errored (code=").concat(ev.code, " reason=").concat(ev.reason, "), reconnecting..."));
                                        setTimeout(function () {
                                            if (!reinited) {
                                                // Set this in case we get both onerror and onclose for the same socket instance.
                                                reinited = true;
                                                _this.init();
                                            }
                                        }, this.options.reconnectTimeoutMillis);
                                        return [2 /*return*/];
                                }
                            });
                        }); };
                        this.ws.onmessage = function (ev) {
                            _this.onmessage(ev);
                        };
                        if (this.ws.readyState === this.ws.OPEN) {
                            this._doOnOpen();
                        }
                        else {
                            this.ws.onopen = function () { return _this._doOnOpen(); };
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    RobustWebSocket.prototype._doOnOpen = function () {
        return __awaiter(this, void 0, void 0, function () {
            var maybePromise, _i, _a, f;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!this.options.onOpen) return [3 /*break*/, 2];
                        maybePromise = this.options.onOpen(this.ws);
                        if (!maybePromise) return [3 /*break*/, 2];
                        return [4 /*yield*/, maybePromise];
                    case 1:
                        _b.sent();
                        _b.label = 2;
                    case 2:
                        this.isOpen = true;
                        for (_i = 0, _a = this.pendingOnOpens; _i < _a.length; _i++) {
                            f = _a[_i];
                            try {
                                f();
                            }
                            catch (e) {
                                console.error("Error running pending onOpen callback", e);
                            }
                        }
                        this.pendingOnOpens = [];
                        return [2 /*return*/];
                }
            });
        });
    };
    RobustWebSocket.prototype._doWhenOpen = function (f) {
        if (!this.isOpen || this.ws.readyState !== this.ws.OPEN) {
            this.pendingOnOpens.push(f);
        }
        else {
            f();
        }
    };
    /**
     * Send a message to the server. If the socket is not open, the message will be queued until the
     * connection is reestablished, at which point it will be sent in order.  It is still possible
     * that messages can be lost if the connection is broken in transit or right before.
     */
    RobustWebSocket.prototype.send = function (msg) {
        var _this = this;
        this._doWhenOpen(function () {
            _this.ws.send(msg);
        });
    };
    // Close the connection to the server.  It will not be reestablished in this case.
    RobustWebSocket.prototype.close = function (code, reason) {
        this.closedManually = true;
        this.wantReconnect = false;
        if (this.ws.close) {
            this.ws.close(code, reason);
        }
    };
    RobustWebSocket.prototype.forceReconnect = function () {
        this.closedManually = true;
        this.ws.close();
    };
    return RobustWebSocket;
}());
exports.RobustWebSocket = RobustWebSocket;
function messageAsyncIterator() {
    var _a;
    var done = false;
    var nextResolve = null;
    var messages = [];
    return _a = {
            onMessage: function (msg) {
                if (nextResolve !== null) {
                    nextResolve({
                        done: false,
                        value: msg,
                    });
                    return;
                }
                messages.push(msg);
            },
            onDisconnect: function (_, wanted) {
                done = wanted;
                if (nextResolve) {
                    nextResolve({
                        done: true,
                        value: null,
                    });
                }
            },
            next: function () {
                if (messages.length > 0) {
                    return Promise.resolve({
                        done: false,
                        value: messages.shift(), // eslint-disable-line
                    });
                }
                if (done) {
                    return Promise.resolve({
                        done: true,
                        value: null,
                    });
                }
                return new Promise(function (resolve) {
                    nextResolve = resolve;
                });
            }
        },
        _a[Symbol.asyncIterator] = function () {
            return this;
        },
        _a;
}
exports.messageAsyncIterator = messageAsyncIterator;
//# sourceMappingURL=index.js.map